-- Version 7.1.5
local BagBox, BankBox, Search, B, Match, Med, Box, Found, Inject,Extra, Skip, laststring,ilvlcompare,ilvl, ilvl2
Bind={"unbound","bop","boe","",""}
function BSP_Search(text,I_link)
	if not(text) then return false end
	if laststring ~= text then
		Match={}
		Extra=0
		ilvlcompare,ilvl, ilvl2=nil,0,0
		for word in text:gmatch("%S+") do
			Skip=false
			if string.find(word,"+") and string.len(word)>=3 then
				if ilvlcompare then
					ilvlcompare="r"
					ilvl2=tonumber(strmatch(word,"%d+"))
					Skip=true
				else
					ilvlcompare="+"
					ilvl=tonumber(strmatch(word,"%d+"))
					Extra=Extra+1
					Skip=true
				end
			end
			if string.find(word,"-") and string.len(word)>=3 then
				if ilvlcompare then
					ilvlcompare="r"
					ilvl2=tonumber(strmatch(word,"%d+"))
					Skip=true
				else
					ilvlcompare="-"
					ilvl=tonumber(strmatch(word,"%d+"))
					Extra=Extra+1
					Skip=true
				end
			end
			if not(Skip) then
				table.insert(Match,strlower(word))
			end
		end
		laststring=text
	end
	Med={}
	if I_link~="" and I_link~="[]" and I_link  then
		local I_stats=GetItemStats(I_link)
		if I_stats then
			for k,v in pairs(I_stats) do
				table.insert(Med,strlower(k))
			end
		end
		local namn,_,_,_,_,_,kind,_,place,_,_,_,_,bind=GetItemInfo(I_link)
		if bind then tinsert(Med,Bind[bind+1]) end

		local Ilvl=GetDetailedItemLevelInfo(I_link)
		if kind then table.insert(Med,strlower(kind)) end
		if Ilvl then table.insert(Med,Ilvl) end
		if not(place=="") and place then table.insert(Med,strlower(place)) end
		Found=0
		if Ilvl and ilvlcompare=="+" then
			if Ilvl>=ilvl then Found=Found+1 end
		end
		if Ilvl and ilvlcompare=="-" then
			if Ilvl<=ilvl then Found=Found+1 end
		end
		if Ilvl and ilvlcompare=="r" then
			if (Ilvl<=ilvl and Ilvl>=ilvl2) or (Ilvl>=ilvl and Ilvl<=ilvl2) then Found=Found+1 end
		end
		local comp=#Match + Extra
		for i=1, #Match do
			for q=1,#Med do
				if string.find(Med[q],Match[i]) then
					Found=Found+1
					break
				end
			end
		end
		if Found==comp then
			return true
		else
			return false
		end
	else
		return false
	end
end



-----------------------------Add this search to other bag addons-----------------

local eventframe = CreateFrame("FRAME", "BspEventframe");

eventframe:RegisterEvent("ADDON_LOADED")

local len, sub, find, format, gsub

local function eventHandler(self,event,...)
	if event=="ADDON_LOADED" and ...=="Bagsearchplus" then
		Inject()
	elseif event=="ADDON_LOADED" and ...=="ElvUI" then
		Inject()
	elseif event=="ADDON_LOADED" and ...=="ArkInventory" then
		Inject()
	elseif event=="ADDON_LOADED" and ...=="Bagnon" then
		Inject()
	end
end

eventframe:SetScript("OnEvent", eventHandler);
---------------------------------Standard UI

local function UpdateBlizzResults(frame)
	local id = frame:GetID();
	local name = frame:GetName().."Item";
	local itemButton, Box,kind,iD,Found
	local _, isFiltered;
	--Match={}
	--Med={}
	Box=strlower(BagItemSearchBox:GetText())
	--for word in Box:gmatch("%S+") do table.insert(Match,strlower(word)) end
	for i=1, frame.size, 1 do
		Med={}
		local stats=false
		itemButton = _G[name..i] or frame["Item"..i];
		iD = itemButton:GetID()
		_, _, _, _, _, _, _, isFiltered = GetContainerItemInfo(id, iD);
		if ( isFiltered ) then
			if not(BSP_Search(Box,GetContainerItemLink(id,iD))) then
				itemButton.searchOverlay:Show();
			else
			itemButton.searchOverlay:Hide();
			end
		else
			itemButton.searchOverlay:Hide();
		end
	end
end
hooksecurefunc("ContainerFrame_UpdateSearchResults",UpdateBlizzResults)
----------------------------------Elv UI---------------------------
local function BSP_Elv(B)
	function B:SetSearch(query)
	--Match={}
	--for word in query:gmatch("%S+") do table.insert(Match,strlower(word)) end
		local empty = len(query:gsub(' ', '')) == 0
		for _, bagFrame in pairs(B.BagFrames) do
			for _, bagID in ipairs(bagFrame.BagIDs) do
				for slotID = 1, GetContainerNumSlots(bagID) do
					local _, _, _, _, _, _, link = GetContainerItemInfo(bagID, slotID);
					local button = bagFrame.Bags[bagID][slotID];
					local success, result = pcall(Search.Matches, Search, link, query)
					if ( empty or (success and result) ) or BSP_Search(query,link) then
						SetItemButtonDesaturated(button);
						button:SetAlpha(1);
					else
						SetItemButtonDesaturated(button, 1);
						button:SetAlpha(0.4);
					end
				end
			end
		end
		if(ElvUIReagentBankFrameItem1) then
			for slotID=1, 98 do
				local _, _, _, _, _, _, link = GetContainerItemInfo(REAGENTBANK_CONTAINER, slotID);
				local button = _G["ElvUIReagentBankFrameItem"..slotID]
				local success, result = pcall(Search.Matches, Search, link, query)
				if ( empty or (success and result) ) or BSP_Search(query,link) then
					SetItemButtonDesaturated(button);
					button:SetAlpha(1);
				else
					SetItemButtonDesaturated(button, 1);
					button:SetAlpha(0.4);
				end
			end
		end
	end
end
----------------------------For ArkInventory---------------------

local function BSP_MatchesFilter( frame )

	local loc_id = frame.ARK_Data.loc_id
	local matches = false

	local f = string.trim( string.lower( ArkInventory.Global.Location[loc_id].filter or "" ) )
	if f == "" then
		matches = true
	else
		local i = ArkInventory.Frame_Item_GetDB( frame ) or { }
		local info = ArkInventory.ObjectInfoArray( i.h, i )
		local n = string.lower( info.name or "" )
		if string.find( n, f ) then
			matches = true
		else
			if BSP_Search(f,i.h)==true then
				matches = true
			end
		end
	end
	return matches
end

--------------------------------------For Bagnon------------------------
local function BSP_Bagnon()
local ItemSearch = LibStub('LibItemSearch-1.2')
	function Bagnon.ItemSlot:UpdateSearch()
		local search = Bagnon.search or ''
		--local Match={}
		--for word in search:gmatch("%S+") do table.insert(Match,strlower(word)) end
		local matches = search == '' or ItemSearch:Matches(self:GetItem(), search)
		if matches then
			self:SetAlpha(1)
			self:UpdateLocked()
			self:UpdateBorder()
		else
			if BSP_Search(search,self.hasItem)==false then
				self:SetLocked(true)
				self:SetAlpha(0.4)
				self:HideBorder()
			else
				self:SetAlpha(1)
				self:UpdateLocked()
				self:UpdateBorder()
			end
		end
	end
end

-----------------------------
function Inject()
	if IsAddOnLoaded("ElvUI") then
		len, sub, find, format, gsub = string.len, string.sub, string.find, string.format, string.gsub
		local E, L, V, P, G = unpack(ElvUI); --Inport: Engine, Locales, PrivateDB, ProfileDB, GlobalDB
		Search = LibStub('LibItemSearch-1.2-ElvUI')
		B = E:GetModule('Bags')
		eventframe:UnregisterEvent("ADDON_LOADED")
		--B.SetSearch = MyINVENTORY_SEARCH_UPDATE
		BSP_Elv(B)
	end
	if IsAddOnLoaded("ArkInventory") then
		ArkInventory.Frame_Item_MatchesFilter=BSP_MatchesFilter
	end
	if IsAddOnLoaded("Bagnon") then
		BSP_Bagnon()
	end
end
